Handle post actions

Report processing actions are sent in an Ajax request to exchange data with the Web API service. You can handle post actions event to customize the Ajax requests.

  • AjaxBeforeLoad
  • AjaxSuccess
  • AjaxError

AjaxBeforeLoad

This event can be triggered before an Ajax request is sent to the Report Viewer Web API service. It allows you to set additional headers, custom data in the Ajax request. The following code sample demonstrates adding custom authorization header and passing default parameter values to service.

Add custom header in Ajax request

Initialize the ajaxBeforeLoad event in the script and add the authorization token to the headers property

    <script type="text/javascript">
        $(function () {
            $("#viewer").boldReportViewer({
                reportServiceUrl: "/api/ReportViewer",
                reportPath: '~/Resources/docs/sales-order-detail.rdl',
                ajaxBeforeLoad: onAjaxRequest
            });
        });

        function onAjaxRequest(args) {
            args.headers.push({ Key: 'Authorization', Value: btoa('guest', 'demo@123') });
        }
    </script>

You can view the Web API service used in the above code from the Reporting Service git hub location. For more information, see Samples and demos. In this tutorial, the sales-order-detail.rdl report is used, and it can be downloaded from here.

Get the custom header value from the HttpContext header collection using the key name specified at client-side.

        string authenticationHeader;

        public object PostReportAction(Dictionary<string, object> jsonResult)
        {
            if (jsonResult != null)
            {
                //Get client side custom ajax header and store in local variable
                authenticationHeader = HttpContext.Current.Request.Headers["Authorization"];

                //Perform your custom validation here
                if (authenticationHeader == "")
                {
                    return new Exception("Authentication failed!!!");
                }
                else
                {
                    return ReportHelper.ProcessReport(jsonResult, this);
                }
            }

            return null;
        }

Perform your own action to validate the header values.

Pass custom data in Ajax request

Use the data property to set custom data to the server in the Ajax request. In the following code sample, parameter values are passed to the server-side.

        <script type="text/javascript">
            $(function () {
                $("#viewer").boldReportViewer({
                    reportServiceUrl: "/api/ReportViewer",
                    reportPath: '~/Resources/docs/sales-order-detail.rdl',
                    ajaxBeforeLoad: onAjaxRequest
                });
            });

            function onAjaxRequest(args) {
                //Passing custom data to server
                var customerID = "CI0021";
                args.data = customerID;
            }
        </script>

The custom data values are stored in the customData header key, and you can store them in the local property. The following code sample demonstrates to change the datasource connection strings based on Customer ID in the OnInitReportOptions method.

        string customerID = null;

        public object PostReportAction(Dictionary<string, object> jsonResult)
        {
            if (jsonResult != null)
            {
                if (jsonResult.ContainsKey("customData"))
                {
                    //Get client side custom data and store in local variable.
                    customerID = jsonResult["customData"].ToString();
                }
            }

            return ReportHelper.ProcessReport(jsonResult, this);
        }

        [NonAction]
        public void OnInitReportOptions(ReportViewerOptions reportOption)
        {
            if (customerID != null)
            {
                if(customerID.Contains("CI0021"))
                {
                    //If you are changing the connection string based on customer id then could you please change the connection string as below.
                    //reportOption.ReportModel.DataSourceCredentials.Add(new BoldReports.Web.DataSourceCredentials("<Datasource name>", "<connection string>"));
                    reportOption.ReportModel.DataSourceCredentials.Add(new BoldReports.Web.DataSourceCredentials("<database>", "Data Source=<instancename>;Initial Catalog=<database>;"));
                }
                else if(customerID.Contains("CI0022"))
                {
                    //If you are changing the connection string based on customer id then could you please change the connection string as below.
                    //reportOption.ReportModel.DataSourceCredentials.Add(new BoldReports.Web.DataSourceCredentials("<Datasource name>", "<connection string>"));
                    reportOption.ReportModel.DataSourceCredentials.Add(new BoldReports.Web.DataSourceCredentials("<database>", "Data Source=<instancename>;Initial Catalog=<database>;"));
                }
            }
        }

AjaxSuccess

To perform custom action or show user defined message, use the ajaxSuccess event on the successful Ajax request.

        <script type="text/javascript">
            $(function () {
                $("#viewer").boldReportViewer({
                    reportServiceUrl: "/api/ReportViewer",
                    reportPath: '~/Resources/docs/sales-order-detail.rdl',
                    ajaxBeforeLoad: onAjaxRequest,
                    ajaxSuccess: onAjaxSuccess
                });
            });

            function onAjaxRequest(args) {
                args.headers.push({ Key: 'Authorization', Value: btoa('guest', 'demo@123') });

                //Passing custom parameter data to server
                args.data = [{ name: 'SalesOrderNumber', labels: ['SO50756'], values: ['SO50756'] }];
            }

            function onAjaxSuccess(args) {
                //Perform your custom success message here
                alert("Ajax request success!!!");
            }
        </script>

AjaxError

The ajaxError event is called, if an error occurred with the request, you can display the customized error detail in the event method.

        <script type="text/javascript">
            $(function () {
                $("#viewer").boldReportViewer({
                    reportServiceUrl: "/api/ReportViewer",
                    reportPath: '~/Resources/docs/sales-order-detail.rdl',
                    ajaxBeforeLoad: onAjaxRequest,
                    ajaxError: onAjaxFailure
                });
            });

            function onAjaxRequest(args) {
                args.headers.push({ Key: 'Authorization', Value: btoa('guest', 'demo@123') });

                //Passing custom parameter data to server
                args.data = [{ name: 'SalesOrderNumber', labels: ['SO50756'], values: ['SO50756'] }];
            }

            function onAjaxFailure(args) {
                alert("Status: " + args.status + "\n" +
                    "Error: " + args.responseText);
            }
        </script>

You can never have both an error and a success callback with a request.

Change Report Viewer default WEB API action with custom endpoint

The actionName event argument allows to change the methods of IReportController to custom WEB API action endpoints.

Change report processing endpoint

Create a new Web Api action method in Report Viewer API controller as in the following code snippet,

        public object PostReportCustomAction(Dictionary<string, object> jsonResult)
        {
          return ReportHelper.ProcessReport(jsonResult, this);
        }

The custom method must have the Dictionary<TKey, TValue> argument and add code ReportHelper.ProcessReport for processing the report.

Register the event ajaxBeforeLoad in your html page and set the newly created name to actionName property as in the below code snippet.

      <script type="text/javascript">
        $(function () {
            $("#viewer").boldReportViewer({
                reportServiceUrl: "/api/ReportViewer",
                reportPath: '~/Resources/docs/sales-order-detail.rdl',
                ajaxBeforeLoad: onAjaxRequest
            });
        });

        function onAjaxRequest(args) {
            args.actionName = "PostReportCustomAction";
        }
    </script>

Change export action endpoint

Create a new Web Api action method in Report Viewer API controller as in the following code snippet,

        public object ExportReportCustomAction()
        {
            return ReportHelper.ProcessReport(null, this);
        }

The custom method must have the code ReportHelper.ProcessReport for exporting the report.

Register the event onExportProgressChanged in your html page and set the newly created name to actionName property as in the below code snippet.

      <script type="text/javascript">
        $(function () {
            $("#viewer").boldReportViewer({
                reportServiceUrl: "/api/ReportViewer",
                reportPath: '~/Resources/docs/sales-order-detail.rdl',
                exportProgressChanged: "onExportProgressChanged"
            });
        });

        function  onExportProgressChanged(args) {
            if(args.stage === "exportStarted"){
              args.actionName = "ExportReportCustomAction";
            }
        }
    </script>

Handle post actions

Report processing actions are sent in an Ajax request to exchange data with the Web API service. You can handle post actions event to customize the Ajax requests.

  • AjaxBeforeLoad
  • AjaxSuccess
  • AjaxError

AjaxBeforeLoad

This event can be triggered before an Ajax request is sent to the Report Viewer Web API service. It allows you to set additional headers and custom data in the Ajax request. The following code sample demonstrates adding custom authorization header and passing default parameter values to service.

Add custom header in Ajax request

Initialize the ajaxBeforeLoad event in the script and add the authorization token to the headers property.

<bold-reportviewer id="reportViewer_Control"
    [reportServiceUrl] = "serviceUrl"
    [processingMode] = "Remote"
    [reportServerUrl] = "serverUrl"
    [reportPath] = "reportPath"
    (ajaxBeforeLoad) = "onAjaxRequest($event)">
</bold-reportviewer>
import { Component, ViewChild } from '@angular/core';
import { BoldReportsAngularModule } from '@boldreports/angular-reporting-components/src/core';

@Component({
    selector: 'ej-app',
    templateUrl: './app.component.html',
    styleUrls: ['./app.component.css']
})
export class AppComponent {
    public serviceUrl: string;
    public reportPath: string;
    public serverUrl: string;

    constructor() {

        this.serviceUrl = 'https://demos.boldreports.com/services/api/ReportApi';
        this.reportPath = 'Sales Order Detail.rdl';

    }

    onAjaxRequest(event) {
         event.headers.push({ Key: 'Authorization', Value: 'demo@123' });
    }
}

In this tutorial, the Sales Order Detail.rdl report is used, and it can be downloaded from here.

Get the custom header value from the HttpContext header collection using the key name specified at client side.

        string authenticationHeader;

        public object PostReportAction(Dictionary<string, object> jsonResult)
        {
            if (jsonResult != null)
            {
                //Get client side custom ajax header and store in local variable
                authenticationHeader = HttpContext.Current.Request.Headers["Authorization"];

                //Perform your custom validation here
                if (authenticationHeader == "")
                {
                    return new Exception("Authentication failed!!!");
                }
                else
                {
                    return ReportHelper.ProcessReport(jsonResult, this);
                }
            }

            return null;
        }

Perform your own action to validate the header values.

Pass custom data in Ajax request

Use the data property to set custom data to the server in the Ajax request. In the following code sample, parameter values are passed to the server side.

<bold-reportviewer id="reportViewer_Control"
    [reportServiceUrl] = "serviceUrl"
    [processingMode] = "Remote"
    [reportServerUrl] = "serverUrl"
    [reportPath] = "reportPath"
    (ajaxBeforeLoad) = "onAjaxRequest($event)">
</bold-reportviewer>
import { Component, ViewChild } from '@angular/core';
import { BoldReportsAngularModule } from '@boldreports/angular-reporting-components/src/core';

@Component({
    selector: 'ej-app',
    templateUrl: './app.component.html',
    styleUrls: ['./app.component.css']
})
export class AppComponent {
    public serviceUrl: string;
    public reportPath: string;
    public serverUrl: string;

    constructor() {

        this.serviceUrl = 'https://demos.boldreports.com/services/api/ReportApi';
        this.reportPath = 'Sales Order Detail.rdl';

    }

    onAjaxRequest(event) {
        //Passing custom data to server
        var customerID = "CI0021";
        event.data = customerID;
    }
}

The custom data values are stored in the customData header key, and you can store them in the local property. The following code sample demonstrates to change the datasource connection strings based on Customer ID in the OnInitReportOptions method.

        string customerID = null;

        public object PostReportAction(Dictionary<string, object> jsonResult)
        {
            if (jsonResult != null)
            {
                if (jsonResult.ContainsKey("customData"))
                {
                    //Get client side custom data and store in local variable.
                    customerID = jsonResult["customData"].ToString();
                }
            }

            return ReportHelper.ProcessReport(jsonResult, this);
        }

        public void OnInitReportOptions(ReportViewerOptions reportOption)
        {
            if (customerID != null)
            {
                if(customerID.Contains("CI0021"))
                {
                    //If you are changing the connection string based on customer id then could you please change the connection string as below.
                    //reportOption.ReportModel.DataSourceCredentials.Add(new BoldReports.Web.DataSourceCredentials("<Datasource name>", "<connection string>"));
                    reportOption.ReportModel.DataSourceCredentials.Add(new BoldReports.Web.DataSourceCredentials("<database>", "Data Source=<instancename>;Initial Catalog=NorthwindSdf;"));
                }
                else if(customerID.Contains("CI0022"))
                {
                    //If you are changing the connection string based on customer id then could you please change the connection string as below.
                    //reportOption.ReportModel.DataSourceCredentials.Add(new BoldReports.Web.DataSourceCredentials("<Datasource name>", "<connection string>"));
                    reportOption.ReportModel.DataSourceCredentials.Add(new BoldReports.Web.DataSourceCredentials("<database>", "Data Source=<instancename>;Initial Catalog=NorthwindSdf;"));
                }
            }
        }

AjaxSuccess

To perform custom action or show user defined message, use the ajaxSuccess event on the successful Ajax request.

<bold-reportviewer id="reportViewer_Control"
    [reportServiceUrl] = "serviceUrl"
    [processingMode] = "Remote"
    [reportServerUrl] = "serverUrl"
    [reportPath] = "reportPath"
    (ajaxSuccess) = "onAjaxSuccess($event)">
</bold-reportviewer>
import { Component, ViewChild } from '@angular/core';
import { BoldReportsAngularModule } from '@boldreports/angular-reporting-components/src/core';

@Component({
    selector: 'ej-app',
    templateUrl: './app.component.html',
    styleUrls: ['./app.component.css']
})
export class AppComponent {
    public serviceUrl: string;
    public reportPath: string;
    public serverUrl: string;

    constructor() {

        this.serviceUrl = 'https://demos.boldreports.com/services/api/ReportApi';
        this.reportPath = 'Sales Order Detail.rdl';

    }

    onAjaxSuccess(event) {
        //Perform your custom success message here
        alert("Ajax request success!!!");
    }
}

AjaxError

The ajaxError event is called, if an error occurred with the Ajax request. You can display the customized error details in the event method.

<bold-reportviewer id="reportViewer_Control"
    [reportServiceUrl] = "serviceUrl"
    [processingMode] = "Remote"
    [reportServerUrl] = "serverUrl"
    [reportPath] = "reportPath"
    (ajaxError) = "onAjaxFailure($event)">
</bold-reportviewer>
import { Component, ViewChild } from '@angular/core';
import { BoldReportsAngularModule } from '@boldreports/angular-reporting-components/src/core';

@Component({
    selector: 'ej-app',
    templateUrl: './app.component.html',
    styleUrls: ['./app.component.css']
})
export class AppComponent {
    public serviceUrl: string;
    public reportPath: string;
    public serverUrl: string;

    constructor() {

        this.serviceUrl = 'https://demos.boldreports.com/services/api/ReportApi';
        this.reportPath = 'Sales Order Detail.rdl';

    }

    onAjaxFailure(event) {
        alert("Status: " + event.status + "\n" +
                    "Error: " + event.responseText);
    }
}

You can never have both an error and a success callback with a request.

Handle post actions

Report processing actions are sent in an Ajax request to exchange data with the Web API service. You can handle post actions event to customize the Ajax requests.

  • AjaxBeforeLoad
  • AjaxSuccess
  • AjaxError

AjaxBeforeLoad

This event can be triggered before an Ajax request is sent to the Report Viewer Web API service. It allows you to set additional headers and custom data in the Ajax request. The following code sample demonstrates adding custom authorization header and passing default parameter values to service.

Add custom header in Ajax request

Initialize the ajaxBeforeLoad event in the script and add the authorization token to the headers property.

 function App() {
     return (<div id="viewer" style={viewerStyle}>
     <BoldReportViewerComponent id="reportviewer-container"
     reportServiceUrl = {'https://demos.boldreports.com/services/api/ReportViewer'}
     reportPath = { 'Sales Order Detail.rdl' }
     ajaxBeforeLoad = {onAjaxRequest}
     >
     </BoldReportViewerComponent>
     </div>);
   }
  
   function onAjaxRequest(event) {
     event.headers.push({
     Key: 'Authorization', Value: 'demo@123'
     });
   }

In this tutorial, the Sales Order Detail.rdl report is used, and it can be downloaded from here.

Get the custom header value from the HttpContext header collection using the key name specified at client side.

        string authenticationHeader;

        public object PostReportAction(Dictionary<string, object> jsonResult)
        {
            if (jsonResult != null)
            {
                //Get client side custom ajax header and store in local variable
                authenticationHeader = HttpContext.Current.Request.Headers["Authorization"];

                //Perform your custom validation here
                if (authenticationHeader == "")
                {
                    return new Exception("Authentication failed!!!");
                }
                else
                {
                    return ReportHelper.ProcessReport(jsonResult, this);
                }
            }

            return null;
        }

Perform your own action to validate the header values.

Pass custom data in Ajax request

Use the data property to set custom data to the server in the Ajax request. In the following code sample, parameter values are passed to the server side.

function App() {
     return (<div id="viewer" style={viewerStyle}>
     <BoldReportViewerComponent id="reportviewer-container"
     reportServiceUrl = {'https://demos.boldreports.com/services/api/ReportViewer'}
     reportPath = { 'Sales Order Detail.rdl' }
     ajaxBeforeLoad = {onAjaxRequest}
     >
     </BoldReportViewerComponent>
     </div>);
   }
  
   function onAjaxRequest(event) {
     //Passing custom data to server
     var customerID = "CI0021";
     event.data = customerID;
   }

The custom data values are stored in the customData header key, and you can store them in the local property. The following code sample demonstrates to change the datasource connection strings based on Customer ID in the OnInitReportOptions method.

        string CustomerID = null;

        public object PostReportAction(Dictionary<string, object> jsonResult)
        {
            if (jsonResult != null)
            {
                if (jsonResult.ContainsKey("customData"))
                {
                    //Get client side custom data and store in local variable.
                    CustomerID = jsonResult["customData"].ToString();
                }
            }

            return ReportHelper.ProcessReport(jsonResult, this);
        }

        public void OnInitReportOptions(ReportViewerOptions reportOption)
        {
            if (CustomerID != null)
            {
                if(CustomerID.Contains("CI0021"))
                {
                    //If you are changing the connection string based on customer id then could you please change the connection string as below.
                    //reportOption.ReportModel.DataSourceCredentials.Add(new BoldReports.Web.DataSourceCredentials("<Datasource name>", "<connection string>"));
                    reportOption.ReportModel.DataSourceCredentials.Add(new BoldReports.Web.DataSourceCredentials("<database>", "Data Source=<instancename>;Initial Catalog=<database>;"));
                }
                else if(CustomerID.Contains("CI0022"))
                {
                    //If you are changing the connection string based on customer id then could you please change the connection string as below.
                    //reportOption.ReportModel.DataSourceCredentials.Add(new BoldReports.Web.DataSourceCredentials("<Datasource name>", "<connection string>"));
                    reportOption.ReportModel.DataSourceCredentials.Add(new BoldReports.Web.DataSourceCredentials("<database>", "Data Source=<instancename>;Initial Catalog=<database>;"));
                }
            }
        }

AjaxSuccess

To perform custom action or show user defined message, use the ajaxSuccess event on the successful Ajax request.

function App() {
     return (<div id="viewer" style={viewerStyle}>
     <BoldReportViewerComponent id="reportviewer-container"
     reportServiceUrl = {'https://demos.boldreports.com/services/api/ReportViewer'}
     reportPath = { 'Sales Order Detail.rdl' }
     ajaxSuccess = {onAjaxSuccess}
     >
     </BoldReportViewerComponent>
     </div>);
   }
  
   function onAjaxSuccess(event) {
        //Perform your custom success message here
        alert("Ajax request success!!!");
    }

AjaxError

The ajaxError event is called, if an error occurred with the Ajax request. You can display the customized error details in the event method.

function App() {
     return (<div id="viewer" style={viewerStyle}>
     <BoldReportViewerComponent id="reportviewer-container"
     reportServiceUrl = {'https://demos.boldreports.com/services/api/ReportViewer'}
     reportPath = { 'Sales Order Detail.rdl' }
     ajaxError = {onAjaxFailure}
     >
     </BoldReportViewerComponent>
     </div>);
   }
  
   function onAjaxFailure(event) {
        alert("Status: " + event.status + "\n" +
                    "Error: " + event.responseText);
    }

You can never have both an error and a success callback with a request.